> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://contentful.com/developers/docs/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://contentful.com/_mcp/server. # Update a role PUT https://api.contentful.com/spaces/{space_id}/roles/{role_id} Content-Type: application/vnd.contentful.management.v1+json Use this endpoint to update an existing role. You cannot use the endpoint to create a new role with a specific id. Reference: https://contentful.com/developers/docs/references/content-management-api/roles/update-a-role ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `space_id` (string, required) — ID of the space in form of a string - `role_id` (string, required) — ID of the role in a form of a string ### Body (application/vnd.contentful.management.v1+json) This endpoint expects a map from string to any. - `map from string to any` ## Response ### 200 OK - Request successful - `map from string to any` ## Examples **Request** ```json { "description": "Test role", "name": "Some role", "permissions": { "ContentDelivery": "all", "ContentModel": [ "read" ], "EnvironmentAliases": "all", "Environments": "all", "Settings": "all" }, "policies": [ { "actions": [ "read", "create", "update", "delete", "publish", "unpublish", "archive", "unarchive" ], "constraint": { "and": [ [ "equals", { "doc": "sys.type" }, "Entry" ] ] }, "effect": "allow" } ] } ``` **Response** ```json { "description": "Test role", "name": "Some role", "permissions": { "ContentDelivery": "all", "ContentModel": [ "read" ], "EnvironmentAliases": "all", "Environments": "all", "Settings": "all" }, "policies": [ { "actions": [ "read", "create", "update", "delete", "publish", "unpublish", "archive", "unarchive" ], "constraint": { "and": [ [ "equals", { "doc": "sys.type" }, "Entry" ] ] }, "effect": "allow" } ], "sys": { "createdAt": "2025-12-20T09:58:14.000Z", "createdBy": { "sys": { "id": "7BslKh9TdKGOK41VmLDjFZ", "linkType": "User", "type": "Link" } }, "id": "0xvkNW6WdQ8JkWlWZ8BC4x", "type": "Role", "updatedAt": "2025-12-20T09:58:14.000Z", "updatedBy": { "sys": { "id": "4FLrUHftHW3v2BLi9fzfjU", "linkType": "User", "type": "Link" } }, "version": 0 } } ``` **SDK Code** ```android Android // Create the Contentful client. final CMAClient client = new CMAClient .Builder() .setAccessToken("") .setSpaceId("") .setEnvironmentId("") .build(); client .roles() .async() .fetchOne( "", "", new CMACallback() { @Override protected void onSuccess(CMARole role) { // The fetched role will be the parameter of this method. // Change it. role .setName("This role is mine!") .setDescription("A test role"); // Create it on Contentful. client .roles() .async() .update( role, new CMACallback() { @Override protected void onSuccess(CMARole result) { // Updated the role successfully. new AlertDialog.Builder(context) .setTitle("Contentful") .setMessage("Role updated." + "\n\nResult: " + result) .show(); } @Override protected void onFailure(RuntimeException exception) { // An error occurred! Inform the user. new AlertDialog.Builder(context) .setTitle("Contentful Error") .setMessage("Could not update a role." + "\n\nReason: " + exception.toString()) .show(); super.onFailure(exception); } } ); } @Override protected void onFailure(RuntimeException exception) { // An error occurred! Inform the user. new AlertDialog.Builder(context) .setTitle("Contentful Error") .setMessage("Could not get the role." + "\n\nReason: " + exception.toString()) .show(); super.onFailure(exception); } } ); ``` ```java Java // Create the Contentful client. final CMAClient client = new CMAClient .Builder() .setAccessToken("") .setSpaceId("") .setEnvironmentId("") .build(); // fetch a role final CMARole role = client .roles() .fetchOne( "", "" ); // change it locally role.setDescription("I changed my mind."); // update it on Contentful client .roles() .update( role ); ``` ```kotlin Kotlin // Create the Contentful client. val client = CMAClient.Builder() .setAccessToken("") .setSpaceId("") .setEnvironmentId("") .build() // fetch a role val role = client .roles() .fetchOne( "", "" ) // change it locally role.description = "I changed my mind." // update it on Contentful client .roles() .update( role ) ``` ```swift Swift We currently don't provide a CMA SDK for this platform. ``` ```js-legacy JavaScript (legacy) import { createClient } from 'contentful-management' const client = createClient({ accessToken: '' }, { type: 'legacy' }) client.getSpace('') .then((space) => space.getRole('')) .then((role) => { role.name = 'New role name' return role.update() }) .then((role) => console.log(`Role ${role.sys.id} updated.`)) .catch(console.error) ``` ```javascript JavaScript import { createClient } from 'contentful-management' const client = createClient({ accessToken: '' }, { type: 'legacy' }) const role = await client.role.update( { spaceId: '', roleId: '', }, { name: 'My role', description: 'My role description', permissions: { ContentModel: [ 'read' ], ContentDelivery: 'all', Environments: 'all', EnvironmentAliases: 'all', Settings: 'all' }, policies: [ { effect: 'allow', actions: [ 'read', 'create', 'update', 'delete', 'publish', 'unpublish', 'archive', 'unarchive' ], constraint: { and: [ [ 'equals', { doc: 'sys.type' }, 'Entry' ] ] } } ] }); ``` ```php PHP $client = new \Contentful\Management\Client(''); $space = $client->getSpaceProxy(''); $role = $space->getRole(''); $role->setName('New role name'); $role->update(); ``` ```ruby Ruby require 'contentful/management' client = Contentful::Management::Client.new('') role = client.roles('').find('') role.name = 'New role name' role.save ``` ```python Python from contentful_management import Client client = Client('') role = client.roles('').find('') role.name = 'New role name' role.save() ``` ```.net .NET // This client should only be created once per application. var httpClient = new HttpClient(); var client = new ContentfulManagementClient(httpClient, "", ""); var role = await client.GetRole(""); role.Name = "Updated role"; var updatedRole = await client.UpdateRole(role); ```